plugin.GetOptionsPanel = function(self)

	-- Create Options Panel --
	optionsPanel = Turbine.UI.Control();
	optionsPanel:SetSize(500, 370);


	-- Options title --
	optionsPanelTitle = Turbine.UI.Label();
	optionsPanelTitle:SetParent(optionsPanel);
	optionsPanelTitle:SetText("Settings");
	optionsPanelTitle:SetSize(400, 30);
	optionsPanelTitle:SetPosition(0, 25);
	optionsPanelTitle:SetFont(Turbine.UI.Lotro.Font.TrajanPro18);
	optionsPanelTitle:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	optionsPanelTitle:SetForeColor(Turbine.UI.Color.Yellow);
	optionsPanelTitle:SetFontStyle(Turbine.UI.FontStyle.Outline);
	optionsPanelTitle:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend);
	optionsPanelTitle:SetBackground(Turbine.UI.Graphic("BeorningWrath/Images/optionsTitleBackground.tga"));


	-- Allow movement--
	option_allowMovement_label = Turbine.UI.Label();
	option_allowMovement_label:SetParent(optionsPanel);
	option_allowMovement_label:SetSize(300, 30);
	option_allowMovement_label:SetPosition(110, 70);
	option_allowMovement_label:SetFont(Turbine.UI.Lotro.Font.Verdana16);
	option_allowMovement_label:SetText("Allow movement");
	option_allowMovement_label:SetForeColor(Turbine.UI.Color.White);
	option_allowMovement_checkbox = Turbine.UI.Lotro.CheckBox();
	option_allowMovement_checkbox:SetParent(optionsPanel);
	option_allowMovement_checkbox:SetSize(20, 20);
	option_allowMovement_checkbox:SetPosition(80, 69);
	option_allowMovement_checkbox:SetChecked(options["enableMovement"]);


	-- Display number --
	option_displayNumber_label = Turbine.UI.Label();
	option_displayNumber_label:SetParent(optionsPanel);
	option_displayNumber_label:SetSize(300, 30);
	option_displayNumber_label:SetPosition(110, 95);
	option_displayNumber_label:SetFont(Turbine.UI.Lotro.Font.Verdana16);
	option_displayNumber_label:SetText("DisplayNumber");
	option_displayNumber_label:SetForeColor(Turbine.UI.Color.White);
	option_displayNumber_checkbox = Turbine.UI.Lotro.CheckBox();
	option_displayNumber_checkbox:SetParent(optionsPanel);
	option_displayNumber_checkbox:SetSize(20, 20);
	option_displayNumber_checkbox:SetPosition(80, 94);
	option_displayNumber_checkbox:SetChecked(options["displayNumber"]);


	-- Hide out of combat --
	option_hideOutOfCombat_label = Turbine.UI.Label();
	option_hideOutOfCombat_label:SetParent(optionsPanel);
	option_hideOutOfCombat_label:SetSize(300, 30);
	option_hideOutOfCombat_label:SetPosition(110, 120);
	option_hideOutOfCombat_label:SetFont(Turbine.UI.Lotro.Font.Verdana16);
	option_hideOutOfCombat_label:SetText("Hide when out of combat");
	option_hideOutOfCombat_label:SetForeColor(Turbine.UI.Color.White);
	option_hideOutOfCombat_checkbox = Turbine.UI.Lotro.CheckBox();
	option_hideOutOfCombat_checkbox:SetParent(optionsPanel);
	option_hideOutOfCombat_checkbox:SetSize(20, 20);
	option_hideOutOfCombat_checkbox:SetPosition(80, 119);
	option_hideOutOfCombat_checkbox:SetChecked(options["hideOutOfCombat"]);


	-- WrathBarLenght --
	option_wrathBarLenght_label = Turbine.UI.Label();
	option_wrathBarLenght_label:SetParent(optionsPanel);
	option_wrathBarLenght_label:SetSize(300, 30);
	option_wrathBarLenght_label:SetPosition(80, 150);
	option_wrathBarLenght_label:SetFont(Turbine.UI.Lotro.Font.Verdana16);
	option_wrathBarLenght_label:SetText("Bar Lenght");
	option_wrathBarLenght_label:SetForeColor(Turbine.UI.Color.White);
	option_wrathBarLenght_textbox = Turbine.UI.Lotro.TextBox();
	option_wrathBarLenght_textbox:SetParent(optionsPanel);
	option_wrathBarLenght_textbox:SetMultiline(false);
	option_wrathBarLenght_textbox:SetFont(Turbine.UI.Lotro.Font.Verdana16);
	option_wrathBarLenght_textbox:SetText(options["wrathBarLenght"]);
	option_wrathBarLenght_textbox:SetSize(100, 20);
	option_wrathBarLenght_textbox:SetPosition(80, 170);
	option_wrathBarLenght_textbox:SetZOrder(100);
	option_wrathBarLenght_textbox.TextChanged = function (sender, args)
		-- Only allow numbers in textbox --
		option_wrathBarLenght_textbox:SetText(option_wrathBarLenght_textbox:GetText():gsub("[^0123456789]", ""));
	end


	-- WrathBarHeight --
	option_wrathBarHeight_label = Turbine.UI.Label();
	option_wrathBarHeight_label:SetParent(optionsPanel);
	option_wrathBarHeight_label:SetSize(300, 30);
	option_wrathBarHeight_label:SetPosition(80, 200);
	option_wrathBarHeight_label:SetFont(Turbine.UI.Lotro.Font.Verdana16);
	option_wrathBarHeight_label:SetText("Bar Height");
	option_wrathBarHeight_label:SetForeColor(Turbine.UI.Color.White);
	option_wrathBarHeight_textbox = Turbine.UI.Lotro.TextBox();
	option_wrathBarHeight_textbox:SetParent(optionsPanel);
	option_wrathBarHeight_textbox:SetMultiline(false);
	option_wrathBarHeight_textbox:SetFont(Turbine.UI.Lotro.Font.Verdana16);
	option_wrathBarHeight_textbox:SetText(options["wrathBarHeight"]);
	option_wrathBarHeight_textbox:SetSize(100, 20);
	option_wrathBarHeight_textbox:SetPosition(80, 220);
	option_wrathBarHeight_textbox:SetZOrder(100);
	option_wrathBarHeight_textbox.TextChanged = function (sender, args)
		-- Only allow numbers in textbox --
		option_wrathBarHeight_textbox:SetText(option_wrathBarHeight_textbox:GetText():gsub("[^0123456789]", ""));
	end


	-- WrathBarGap --
	option_wrathBarGap_label = Turbine.UI.Label();
	option_wrathBarGap_label:SetParent(optionsPanel);
	option_wrathBarGap_label:SetSize(300, 30);
	option_wrathBarGap_label:SetPosition(80, 250);
	option_wrathBarGap_label:SetFont(Turbine.UI.Lotro.Font.Verdana16);
	option_wrathBarGap_label:SetText("Bar Gap");
	option_wrathBarGap_label:SetForeColor(Turbine.UI.Color.White);
	option_wrathBarGap_textbox = Turbine.UI.Lotro.TextBox();
	option_wrathBarGap_textbox:SetParent(optionsPanel);
	option_wrathBarGap_textbox:SetMultiline(false);
	option_wrathBarGap_textbox:SetFont(Turbine.UI.Lotro.Font.Verdana16);
	option_wrathBarGap_textbox:SetText(options["wrathBarGap"]);
	option_wrathBarGap_textbox:SetSize(100, 20);
	option_wrathBarGap_textbox:SetPosition(80, 270);
	option_wrathBarGap_textbox:SetZOrder(100);
	option_wrathBarGap_textbox.TextChanged = function (sender, args)
		-- Only allow numbers in textbox --
		option_wrathBarGap_textbox:SetText(option_wrathBarGap_textbox:GetText():gsub("[^0123456789]", ""));
	end


	-- Apply options button --
	apllyButton = Turbine.UI.Lotro.Button();
	apllyButton:SetText("Apply");
	apllyButton:SetParent(optionsPanel);
	apllyButton:SetSize(150, 20);
	apllyButton:SetPosition(80, 330);
	apllyButton:SetZOrder(100);
	apllyButton.Click = function( sender, args)

		options["enableMovement"] = option_allowMovement_checkbox:IsChecked();
		WrathWindowClass.moveControl:SetMouseVisible(options["enableMovement"])

		options["hideOutOfCombat"] = option_hideOutOfCombat_checkbox:IsChecked();
		if (options["hideOutOfCombat"]) then
			WrathWindowClass.localPlayer.InCombatChanged();
		else
			WrathWindowClass:SetWantsUpdates(false)
			WrathWindowClass:SetOpacity(1)
		end

		options["displayNumber"] = option_displayNumber_checkbox:IsChecked();
		WrathWindowClass.Wrath_label:SetVisible(options["displayNumber"])

		if (option_wrathBarLenght_textbox:GetText() == "") then
			option_wrathBarLenght_textbox:SetText("0")
		end

		if (option_wrathBarHeight_textbox:GetText() == "") then
			option_wrathBarHeight_textbox:SetText("0")
		end

		if (option_wrathBarGap_textbox:GetText() == "") then
			option_wrathBarGap_textbox:SetText("0")
		end

		options["wrathBarLenght"] = option_wrathBarLenght_textbox:GetText();
		options["wrathBarHeight"] = option_wrathBarHeight_textbox:GetText();
		options["wrathBarGap"] = option_wrathBarGap_textbox:GetText();

		WrathWindowClass:UpdateElements();

		notification("Options have been applied.");
	end

	
	-- Return View --
	return optionsPanel;
end